
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《深入解析Android 虚拟机》——2.6　Java内存模型 / iVAN</title>

    <meta name="description" content="《深入解析Android 虚拟机》——2.6　Java内存模型 2.6 Java内存模型 不同的平台,内存模型是不一样的,但是JVM的内存模型规范是统一的.其实Java的多线程并发问题最终都会反映在Java内存模型上,所谓线程安全无非是要控制多个线程对某个资源的有序访问或修改.总结Java的内存模型,要解决两个主要的问题:可见性和有序性. 人们都知道计算机有高速缓存的存在,处理器并不是每次处理数据都是取内存的.JVM定义了自己的内存模型,屏蔽了底层平台内存管理细节,对于Java开发人员,要清楚在JVM内存模型的基础上,如果解决多线程的可见性和有序性. 那么,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《深入解析Android 虚拟机》——2.6　Java内存模型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>2.6　Java内存模型</h3>
<p>不同的平台，内存模型是不一样的，但是JVM的内存模型规范是统一的。其实Java的多线程并发问题最终都会反映在Java内存模型上，所谓线程安全无非是要控制多个线程对某个资源的有序访问或修改。总结Java的内存模型，要解决两个主要的问题：可见性和有序性。</p>
<p>人们都知道计算机有高速缓存的存在，处理器并不是每次处理数据都是取内存的。JVM定义了自己的内存模型，屏蔽了底层平台内存管理细节，对于Java开发人员，要清楚在JVM内存模型的基础上，如果解决多线程的可见性和有序性。</p>
<p>那么，何谓可见性？多个线程之间是不能互相传递数据通信的，它们之间的沟通只能通过共享变量来进行。Java内存模型（JMM）规定了JVM有主内存，主内存是多个线程共享的。当新建一个对象的时候，也是被分配在主内存中，每个线程都有自己的工作内存，工作内存存储了主存的某些对象的副本，当然线程的工作内存大小是有限制的。当线程操作某个对象时，执行顺序如下。</p>
<p>（1）从主存复制变量到当前工作内存（read and load）。</p>
<p>（2）执行代码，改变共享变量值（use and assign）。</p>
<p>（3）用工作内存数据刷新主存相关内容（store and write）。</p>
<p><strong>2.6.1　Java内存模型概述</strong><br />
Java平台自动集成了线程以及多处理器技术，这种集成程度比Java以前诞生的计算机语言要厉害很多。该语言针对多种异构平台的平台独立性而使用的多线程技术支持也是具有开拓性的一面，有时候在开发Java同步和线程安全要求很严格的程序时，往往容易混淆的一个概念就是内存模型。究竟什么是内存模型？内存模型描述了程序中各个变量（实例域、静态域和数组元素）之间的关系，以及在实际计算机系统中将变量存储到内存和从内存中取出变量这样的底层细节，对象最终是存储在内存里面的，这点没有错，但是编译器、运行库、处理器或者系统缓存可以有特权在变量指定内存位置存储或者取出变量的值。</p>
<p>JVM规范定义了线程对主存的操作指令：read、load、use、assign、store、write。当一个共享变量在多个线程的工作内存中都有副本时，如果一个线程修改了这个共享变量，那么其他线程应该能够看到这个被修改后的值，这就是多线程的可见性问题。那么，什么是有序性呢？线程在引用变量时不能直接从主内存中引用，如果线程工作内存中没有该变量，则会从主内存中复制一个副本到工作内存中，这个过程为read-load，完成后线程会引用该副本。当同一线程再度引用该字段时，有可能重新从主存中获取变量副本（read-load-use），也有可能直接引用原来的副本（use），也就是说read、load、use顺序可以由JVM实现系统决定。</p>
<p><strong>2.6.2　主内存与工作内存</strong><br />
Java内存模型的主要目标是定义程序中各个变量的访问规则，即在虚拟机中将变量存储到内存和从内存中取出变量这样的底层细节。此处的变量（Variable）与Java编程中所说的变量略有区别，它包括了实例字段、静态字段和构成数组对象的元素，但是不包括局部变量与方法参数，因为后者是线程私有的，不会被共享，自然就不存在竞争问题。为了获得较好的执行效能，Java内存模型并没有限制执行引擎使用处理器的特定寄存器或缓存来与主内存进行交互，也没有限制即时编译器调整代码执行顺序这类权利。</p>
<p>Java内存模型规定了所有的变量都存储在主内存（Main Memory）中（此处的主内存与介绍物理硬件时的主内存名字一样，两者也可以互相类比，但此处仅是虚拟机内存的一部分）。每条线程还有自己的工作内存（Working Memory，可与前面所讲的处理器高速缓存类比），线程的工作内存中保存了被该线程使用到的变量的主内存副本复制，线程对变量的所有操作（读取、赋值等）都必须在工作内存中进行，而不能直接读写主内存中的变量。不同的线程之间也无法直接访问对方工作内存中的变量，线程间变量值的传递均需要通过主内存来完成，线程、主内存、工作内存三者的交互关系如图2-13所示。</p>
<p><a href="https://yqfile.alicdn.com/916dad49d4d6e9a34920acfb6bc60d9206aa591a.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzkxNmRhZDQ5ZDRkNmU5YTM0OTIwYWNmYjZiYzYwZDkyMDZhYTU5MWEucG5n.jpg"></a></p>
<p><strong>2.6.3　内存间交互操作</strong><br />
关于主内存与工作内存之间具体的交互协议，即一个变量如何从主内存拷贝到工作内存、如何从工作内存同步回主内存之类的实现细节，在Java内存模型中定义了以下8种操作来完成内存间的交互操作。</p>
<ul>
<li>lock（锁定）：作用于主内存的变量，它把一个变量标识为一条线程独占的状态。</li>
<li>unlock（解锁）：作用于主内存的变量，它把一个处于锁定状态的变量释放出来，释放后的变量才可以被其他线程锁定。</li>
<li>read（读取）：作用于主内存的变量，它把一个变量的值从主内存传输到线程的工作内存中，以便随后的load动作使用。</li>
<li>load（载入）：作用于工作内存的变量，它把read操作从主内存中得到的变量值放人工作内存的变量副本中。</li>
<li>use（使用）：作用于工作内存的变量，它把工作内存中一个变量的值传递给执行引擎，每当虚拟机遇到一个需要使用变量值的字节码指令时将会执行这个操作。</li>
<li>assign（赋值）：作用于工作内存的变量，它把一个从执行引擎接收到的值赋给工作内存的变量，每当虚拟机遇到一个给变量赋值的字节码指令时执行这个操作。</li>
<li>store（存储）：作用于工作内存的变量，它把工作内存中一个变量的值传送到主内存中，以便随后的write操作使用。</li>
<li>write（写入）：作用于主内存的变量，它把store操作从工作内存中得到的变量的值放入主内存的变量中。</li>
</ul>
<p>如果要把一个变量从主内存复制到工作内存，那就要按顺序地执行read和load操作；如果要把变量从工作内存同步回主内存，就要按顺序地执行store和write操作。注意，Java内存模型只要求上述两个操作必须按顺序执行，而没有保证必须是连续执行。也就是说read与load之间、store与write之间是可插入其他指令的，如对主内存中的变量a、b进行访问时，一种可能出现的顺序是read a、read b、load b、load a。除此之外，Java内存模型还规定了在执行上述8种基本操作时必须满足如下规则。</p>
<ul>
<li>不允许read和load、store和write操作之一单独出现，即不允许一个变量从主内存读取了但工作内存不接收，或者从工作内存发起回写操作但主内存不接收的情况出现。</li>
<li>不允许一个线程丢弃它最近的assign操作，即变量在工作内存中改变了之后必须把该变化同步回主内存。</li>
<li>不允许一个线程无原因地（没有发生过任何assign操作）把数据从线程的工作内存同步回主内存中。</li>
<li>一个新的变量只能在主内存中“诞生”，不允许在工作内存中直接使用一个未被初始化（load或assign）的变量，换句话说就是对一个变量实施use和store操作之前，必须先执行过了assign和load操作。</li>
<li>一个变量在同一个时刻只允许一条线程对其进行lock操作，但lock操作可以被同一条线程重复执行多次，多次执行lock后，只有执行相同次数的unlock操作时才会解锁变量。</li>
<li>如果对一个变量执行lock操作，将会清空工作内存中此变量的值。在执行引擎使用这个变量前，需要重新执行load或assign操作初始化变量的值。</li>
<li>如果一个变量事先没有被lock操作锁定，则不允许对它执行unlock操作，也不允许去unlock被其他线程锁定住的变量。</li>
<li>对一个变量执行unlock操作之前，必须先把此变量同步回主内存中（执行store和write操作）。</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 05:58:46</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e5%90%8c%e6%ad%a5/" title="同步">同步</a>, <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e7%ba%bf%e7%a8%8b/" title="多线程">多线程</a>, <a href="https://www.iamivan.net/tag/jvm/" title="jvm">jvm</a>, <a href="https://www.iamivan.net/tag/read/" title="read">read</a>, <a href="https://www.iamivan.net/tag/lock/" title="lock">lock</a>, <a href="https://www.iamivan.net/tag/%e5%86%85%e5%ad%98%e6%a8%a1%e5%9e%8b/" title="内存模型">内存模型</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《深入解析Android 虚拟机》——2.6　Java内存模型的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOX2oqb.html" rel="bookmark">《深入解析Android 虚拟机》&mdash;&mdash;第2章，第2&period;6节Java内存模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.6 Java内存模型不同的平台,内存模型是不一样的,但是JVM的内存模型规范是统一的.其实Java的多线程并发问题最终都会反映在Java内存模型上,所谓线程安全无非是要控制多个线程对某个资源的有序访问或修改.总结Java的内存模型,要解决两个主要的问题:可见性和有序性. 人们都知道计算机有高速缓存的存在,处理器并不是每次处理数据都是取内存的.JVM定义了自己的内存模型,屏蔽了底层平台内存管理细节,对于Java开发人员,要清楚在JVM内存模型的基础上,如果解决多线程的可见性和有序性. 那么,何			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKY8j5p.html" rel="bookmark">《深入解析Android 虚拟机》&mdash;&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Android虚拟机技术--Dalvik VM是通往Android高级开发的必备技术!为了让广大读者深入理解Android系统,不再停留在抽象的原理和概念之上,本书对Android虚拟机方面的知识进行了细致分析,这样做的目的是&quot;提炼&quot;出Android系统的本质,了解Android系统究竟是如何运作的,进程和线程之间是如何协调并进的,内存之间是如何分配并存的.并以此为基础,详细讲解了内存优化.垃圾收集和系统优化方面的基本原理和具体实现. Android系统从诞生到现在的短短几年时间			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq7DvZz.html" rel="bookmark">《深入解析Android 虚拟机》&mdash;&mdash;第2章，第2&period;1节虚拟机的作用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 Java虚拟机基础 深入解析Android 虚拟机 Java虚拟机和Android虚拟机十分相似,所以在本书中将以Java虚拟机开始,逐步引领广大读者步入Android虚拟机的世界.在本章的内容中,将简要讲解Java虚拟机技术的基本知识,为读者步入本书后面知识的学习打下基础. 2.1 虚拟机的作用 虚拟机(Virtual Machine)这一概念最初由波佩克与戈德堡定义,是指通过软件模拟的具有完整硬件系统功能的.运行在一个完全隔离环境中的完整计算机系统.由此可见,虚拟机是跟特定硬件无关的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7ZKAz.html" rel="bookmark">Java笔记：Java内存模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 基本概念 &lt;深入理解Java内存模型&gt;详细讲解了java的内存模型,这里对其中的一些基本概念做个简单的笔记.以下内容摘自 &lt;深入理解Java内存模型&gt;读书总结 并发 定义:即,并发(同时)发生.在操作系统中,是指一个时间段中有几个程序都处于已启动运行到运行完毕之间,且这几个程序都是在同一个处理机上运行,但任一个时刻点上只有一个程序在处理机上运行. 并发需要处理两个关键问题:线程之间如何通信及线程之间如何同步. 通信:是指线程之间如何交换信息.在命令式编程中,线程之间的通信机制			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0borlDz.html" rel="bookmark">深入理解Java内存模型（五） 锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				锁的释放-获取建立的happens before 关系 锁是java并发编程中最重要的同步机制.锁除了让 临界区互斥执行外,还可以让释放锁的线程向获取同一个锁的线程发送消息. 下面是锁释放-获取 的示例代码: class MonitorExample { int a = 0; public synchronized void writer() { //1 a++; //2 } //3 public synchronized void reader() { //4 int i = a; //5 -			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGxmOb.html" rel="bookmark">深入理解Java内存模型（二） 重排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果两个操作访问同一个变量,且这两个操作中有一个为写操作,此时这两个操作之间就存在数据依 赖性.数据依赖分下列三种类型: 上 面三种情况,只要重排序两个操作的执行顺序,程序的执行结果将会被改变. 前面提到过,编译 器和处理器可能会对操作做重排序.编译器和处理器在重排序时,会遵守数据依赖性,编译器和处理器不 会改变存在数据依赖关系的两个操作的执行顺序. 注意,这里所说的数据依赖性仅针对单个处理 器中执行的指令序列和单个线程中执行的操作,不同处理器之间和不同线程之间的数据依赖性不被编译器 和处理器考			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEWV0np.html" rel="bookmark">同步与Java内存模型&lpar;一&rpar;序言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:http://gee.cs.oswego.edu/dl/cpj/jmm.html 作者:Doug Lea 译者:萧欢  校对:丁一,方腾飞 先来看如下这个简单的Java类,该类中并没有使用任何的同步. 查看源代码 打印帮助 01 final class SetCheck { 02 private int  a = 0; 03 private long b = 0; 04   05 void set() { 06 a =  1; 07 b = -1; 08 } 09   10 boolean			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP80oqp.html" rel="bookmark">全面理解Java内存模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java内存模型即Java Memory Model,简称JMM.JMM定义了Java 虚拟机(JVM)在计算机内存(RAM)中的工作方式.JVM是整个计算机虚拟模型,所以JMM是隶属于JVM的. 如果我们要想深入了解Java并发编程,就要先理解好Java内存模型.Java内存模型定义了多线程之间共享变量的可见性以及如何在需要的时候对共享变量进行同步.原始的Java内存模型效率并不是很理想,因此Java1.5版本对其进行了重构,现在的Java8仍沿用了Java1.5的版本. 关于并发编程 在并发			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3E1kz.html" rel="bookmark">Akka与Java内存模型的关系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接:http://doc.akka.io/docs/akka/2.3.6/general/jmm.html   译者:clearity 不管你使用的Typesafe系统是Scala版本还是Java版本,都可以使你编写并发程序的过程变得更加容易.这篇文章主要讨论的是Typesafe系统,特别是针对Akka在并发程序中对共享内存的处理部分. Java内存模型 在之前的Java 5 版本中,Java内存模型的定义是很值得商榷的.以至于在共享内存环境下的多线程处理的结果变得多种多样,比如: 线程读			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5Agqp.html" rel="bookmark" class="title">令网站看起来不专业的十个设计误区</a>
					<div>
						  在这个奶茶店都有个响应式网站的时代,你没有网站似乎是一件说不过去的事情.不过当你考虑到自己可能仅仅只是个人名而非名人,你的店铺也算不得什么知名大厂,随便开个网站再说,等影响力扩展到前面十字路口的时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzD3D0p.html" rel="bookmark" class="title">歪解SEO：厨师与SEO的几点联想</a>
					<div>
						厨师?seo?似乎两个风马牛不相及的职业,确实,这两个不是同类.但由于本人总喜欢胡思乱想,又经常去小馆子吃饭,想到SEO与厨师在很多地方是相通的,于是就有了以下六点给大家歪解.这是篇我以前写的旧文(最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp89J4z.html" rel="bookmark" class="title">在Servlet与JSP中取得当前文件所在的相对路径与绝对路径</a>
					<div>
						js|servlet //Servlet中 //JSP中的application对象就是Servlet中的ServerContext,所以在Servlet中是如此获得 //import java.io ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvDxWz.html" rel="bookmark" class="title">快速删除重复记录</a>
					<div>
						数据库中删除重复记录一直是件挺烦人的事,本人收集了Oracle跟SqlServer的快速删除重复记录的方法,供大家参考,希望对大家有所帮助.SQL SERVER 想必每一位SQL SERVER开发人员 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbK6Gnz.html" rel="bookmark" class="title">案例分享：网站改版后在搜索引擎上的措施以及状况</a>
					<div>
						网站改版并非总能一步到位,有时限制于人员,有时候限制于硬件设备,总之总有那么一些原因致使网站一步到位完整改版.笔者就来分享下笔者在特定条件下实施的措施以及成效: 一.静态服务器没弄好,静态网址跳动态网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLReRb.html" rel="bookmark" class="title">在Windows Server 2008中配置精准密码策略和帐户锁定策略</a>
					<div>
						在windows 2000和windows 2003的活动目录域中,我们只能够在Default Domain Policy中为所有用户配置应用一个密码策略和帐户锁定策略,如果我们需要为一些特殊的用户制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN6Dmb.html" rel="bookmark" class="title">CSS注释的一些高级用法</a>
					<div>
						  准修饰选择器(Quasi-qualified selectors) 你应当避免过分修饰选择器,例如如果你能写 .nav{} 就尽量不要写 ul.nav{}.过分修饰选择器将影响性能,影响 clas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVngLYz.html" rel="bookmark" class="title">Photoshop合成恐怖效果的幽灵鬼船</a>
					<div>
						这次的PS翻译教程将为大家带来Photoshop合成死海幽灵鬼船场景的详细制作过程.在本PS翻译教程中,将利用Photoshop的钢笔.变形.滤镜等工具,配合船只.海水.乌云等素材,制作出幽灵鬼船场景 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOawdQM.html" rel="bookmark" class="title">IE安全警告怎么关闭</a>
					<div>
						  自从百度近日开启了HTTPS 安全网页功能之后,每次小编电脑IE浏览器打开百度网页就会弹出一个&quot;安全警告&quot;对话框,提示&quot;是否中查看网页包含的内容将不使用安全的HTTP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oWvgb.html" rel="bookmark" class="title">PS绘制电影海报电影胶片</a>
					<div>
						  电影胶片 步骤1 开始绘制灰色线性渐变一个圆,模仿金属表面.在金属上面创建一个小圆.选择旋转工具(R),按住 Alt键点击中间的金属形状.就会弹出旋转选项窗口,设置角度360/5单击复制按钮.接着 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ewONb.html" rel="bookmark" class="title">win7系统电脑磁盘异常打不开C盘、D盘怎么办</a>
					<div>
						解决方法如下: 1.运行杀毒软件,对全盘进行一次大扫描; 2.在排除电脑病毒导致电脑磁盘打不开的情况下,可能是电脑相关组件注册信息丢失所导致.我们可以利用记事本创建一个名为&quot;a.bat&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg36wBM.html" rel="bookmark" class="title">VC&plus;&plus; &period;NET 2003 &ndash;安装和使用Boost 1&period;30和Blitz&plus;&plus;0&period;6</a>
					<div>
						&quot;C++ increasingly means Visual C++&quot;        - Scott Meyers   &lt; 文章的长度把握不是太好,被 CSDN 的系统裁减, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8lDRb.html" rel="bookmark" class="title">网页-HTML外部链接如何用URL打开内联框架&lpar;急用！在线等&rpar;</a>
					<div>
						问题描述 HTML外部链接如何用URL打开内联框架(急用!在线等) 一个网站,里面使用内联框架对子页面进行调度. 无论子页面如何变化,框架依旧是不变的(域名也不会变化),这导致我获取子页面的地址变得十 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamoO2b.html" rel="bookmark" class="title">js下获得客户端操作系统的函数代码&lpar;1&colon;vista&comma;2&colon;windows7&comma;3&colon;2000&comma;4&colon;xp&comma;5&colon;2003&comma;6&colon;2008&rpar;&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: //获得客户端操作系统(1:vista,2:windows7,3:2000,4:xp,5:2003,6:2008) function GetOSInfo(){ var _pf = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32ZBJz.html" rel="bookmark" class="title">谷歌要做自有品牌Chrome OS上网本</a>
					<div>
						美国科技博客Techcrunch26日报道称,谷歌计划推出自有品牌的基于Chrome OS系统的上网本. 报道称,谷歌上网本将配备触摸屏,代工厂商预计为仁宝,目前双方正在谈判.与之前的Nexus产品不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjkxrp.html" rel="bookmark" class="title">走进天猫商超仓库，简单动作背后的复杂流程</a>
					<div>
						在电商网站上按下&quot;提交订单&quot;,已经是很多&quot;剁手党&quot;(资深网购者)的&quot;规定动作&quot;.但是这个简单动作到商品上门之间,到底要经过怎样的复杂流程?每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV0eZb.html" rel="bookmark" class="title">蓝桥杯 历届试题 九宫重排</a>
					<div>
						问题描述 如下面第一个图的九宫格中,放着 1~8 的数字卡片,还有一个格子空着.与空格子相邻的格子中的卡片可以移动到空格中.经过若干次移动,可以形成第二个图所示的局面. 我们把第一个图的局面记为:12 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kB33M.html" rel="bookmark" class="title">编程-我这个报了什么错？qt太难学了。</a>
					<div>
						问题描述 我这个报了什么错?qt太难学了. #include &quot;mainwindow.h&quot; #include &quot;ui_mainwindow.h&quot; #includ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mxo1Y7b.html" rel="bookmark" class="title">淘宝网&OpenCurlyDoubleQuote;下线&rdquo;打通多媒体 马云将建新媒体公司</a>
					<div>
						未来5年淘宝网交易规模将超过1万亿元.&quot;大淘宝战略&quot;正是淘宝网意图打造更大电子商务生态圈的表现,让所有的网商在网络平台上的营销.支付.物流以及技术问题都顺畅无阻.大淘宝,就是所有想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A2oVz.html" rel="bookmark" class="title">ios客户端-https如何在移动端应用</a>
					<div>
						问题描述 https如何在移动端应用 我在nginx上配了ssl证书(startssl),主流浏览器访问没有问题,现在ios客户端需要跟服务器请求数据,但是把cer(pem--&gt;cer)文件导入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEjOvM.html" rel="bookmark" class="title">Js跑马灯效果</a>
					<div>
						  &lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt; &lt;head&gt;     &lt;title&gt;xy欢迎新同学- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKxgKz.html" rel="bookmark" class="title">黑客举办iPhone 5S指纹识别破解竞赛</a>
					<div>
						本文讲的是 :   黑客举办iPhone 5S指纹识别破解竞赛 , [IT168 资讯]苹果为了更好的保护用户的信息安全而为iPhone 5S带来了全新的指纹识别技术.现在,最新消息显示数十位安全研究 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRLJ6b.html" rel="bookmark" class="title">浏览器-SSH项目如何添加一个ocx控件</a>
					<div>
						问题描述 SSH项目如何添加一个ocx控件 我想请教一下就是,我有一个SSH框架的JAVA项目和ocx控件,现在想把两者结合,让用户访问ie时能加载,这要如何实现?还有如果项目中已经使用了ocx控件, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40Xojz.html" rel="bookmark" class="title">11个小工具帮你页面构建</a>
					<div>
						如今,很多小软件可以让我们在构建页面时派上用场,并起到事半功倍的小伙,下面就一起分享一些关于页面构建常用的一些小工具,大部分是基于firefox的插件.,让你在页面构建时更加得心应手. 一.页面构建必 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKoqBb.html" rel="bookmark" class="title">联想挑战苹果胜算几何</a>
					<div>
						李 迩 本周,网络江湖最引人注目的事莫过于联想的移动互联战略暨新品发布会了,在这场IT界各大门派掌门云集的发布会上,联想不仅发布了&quot;移动互联三剑客&quot;--乐Phone.Skyligh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEDjlM.html" rel="bookmark" class="title">B2C电子商务如何选择搜索引擎营销</a>
					<div>
						B2C即企业通过互联网为消费者提供一个新型的购物环境--网上商店,消费者通过网络在网上购物.在网上支付.由于这种模式节省了客户和企业的时间和空间,大大提高了交易效率,特别对于工作忙碌的上班族,这种模式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRqP1b.html" rel="bookmark" class="title">迅雷下载7&period;9&period;5增加断网掉线重连</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   迅雷7.9.5大幅降低了安装过程的等待时间,并补充了自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEx0nM.html" rel="bookmark" class="title">Could not set limit for &OpenCurlyQuote;nofile&rsquo;&colon; Operation not permitted的处理方法</a>
					<div>
						linux 修改用户可打开的文件数特别大的方法//ssh登陆pam_limits(crond:session): Could not set limit for 'nofile': Operation ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgmwAM.html" rel="bookmark" class="title">阅后即焚式社交聊天工具锐化接收者的专注度</a>
					<div>
						摘要: 阅后即焚式社交聊天工具锐化了接收者的专注度,保护了用户的隐私,因此也受到了越来越多用户的青睐.但是由于对用户所知甚少,又没有应用内购买或者订购服务,此类服务往往很 阅后即焚式社交聊天工具锐化了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYX41Vb.html" rel="bookmark" class="title">求论坛设计</a>
					<div>
						问题描述 求一个论坛网站设计 解决方案 解决方案二:引用楼主wjxsdtc1858的回复: 求一个论坛网站设计 Ifyouaskquestionlikethis,noonebothersgivingy ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
